function love.load()
	require("frames")
	local class = require("class")
	require("LUBE")
	require("serializer")
	
	love.graphics.setBackgroundColor(0,0,0)
	
	-- FRAMES STUFF
	local ip_input = loveframes.Create("textinput")
	ip_input:SetPos(10, 550)
	ip_input:SetWidth(250)
	ip_input:SetLimit(30)
	
	local btn_join = loveframes.Create("button")
	btn_join:SetSize(75, 25)
	btn_join:SetText("Join")
	btn_join:SetPos(270, 550)
	btn_join.OnClick = function(obj)
		ip = ip_input:GetText()
		
		client = lube.udpClient()
		client.handshake = "test_hs"
		client:setPing(true, 5, "ping")
		
		client.callbacks.recv = function(d) recv(d) end
		
		if client:connect("localhost", port, true) then
			print("I am connected to the server on port " .. port)
		end
		
	end
	
	
	-- NETWORKING STUFF
	port = 8710
	ip = "None"
	
	timer = 0	
	
	
	
	-- GAME STUFF
	control = 0
	
	p_speed = 60
	req_send = false
	
	p1 = {
	x = 30,
	y = 30
	}
	p2 = {
	x = 200,
	y = 200
	}
	
end

function love.update(dt)
	loveframes.update(dt)

	if control == 1 then
		if love.keyboard.isDown("w") then
			p1.y = p1.y - p_speed * dt
			if not req_send then req_send = true end
		elseif love.keyboard.isDown("s") then
			p1.y = p1.y + p_speed * dt
			if not req_send then req_send = true end
		end
		if love.keyboard.isDown("a") then
			p1.x = p1.x - p_speed * dt
			if not req_send then req_send = true end
		elseif love.keyboard.isDown("d") then
			p1.x = p1.x + p_speed * dt
			if not req_send then req_send = true end
		end
	elseif control == 2 then
		if love.keyboard.isDown("up") then
			p2.y = p2.y - p_speed * dt
			if not req_send then req_send = true end
		elseif love.keyboard.isDown("down") then
			p2.y = p2.y + p_speed * dt
			if not req_send then req_send = true end
		end
		if love.keyboard.isDown("left") then
			p2.x = p2.x - p_speed * dt
			if not req_send then req_send = true end
		elseif love.keyboard.isDown("right") then
			p2.x = p2.x + p_speed * dt
			if not req_send then req_send = true end
		end
	end
	
	
	-- Sending data to the server
	if client then
		if timer >= 0.02 then
			client:update(dt)
			
			if control == 1 and req_send then
				local s_data = SaveTable(p1)
				print("P1: Sending my data to server..")
				client:send(s_data)
				req_send = false
			elseif control == 2 and req_send then
				local s_data = SaveTable(p2)
				print("P2: Sending my data to server..")
				client:send(s_data)
				req_send = false
			end
			
			timer = 0
		end
		timer = timer + dt
	end
end

function love.draw()
	love.graphics.setColor(255,50,50)
	love.graphics.rectangle("fill", p1.x, p1.y, 20, 20)
	love.graphics.setColor(50,50,255)
	love.graphics.rectangle("fill", p2.x, p2.y, 20, 20)
	loveframes.draw()
end

function recv(data)
	if data == "you are 1" then
		control = 1
		print("You are 1")
	elseif data == "you are 2" then
		control = 2
		print("You are 2")
	else -- then it must be player position updates
		print("We received position updates from the server!")
		if control == 1 then
			local decoded = LoadTable(data)
			p2 = decoded()
		elseif control == 2 then
			local decoded = LoadTable(data)
			p1 = decoded()
		end
	end
end




function love.mousepressed(x, y, button)
	loveframes.mousepressed(x, y, button)
end

function love.mousereleased(x, y, button)
	loveframes.mousereleased(x, y, button)
end

function love.keypressed(key, unicode)
	loveframes.keypressed(key, unicode)
end

function love.keyreleased(key)
	loveframes.keyreleased(key)
end